<?
   //    **********************************************************************************************
   //    phpSOF2Watch
   //    Originally written for Quake 3 by Henrik Schack Jensen (henrik@schack.dk) and ported to 
   //    Soldier of Fortune 2 by Serge Savard.
   //
   //    Author :  Quake3 Class : Henrik Schack Jensen (henrik@schack.dk)
   //              SOF2 Class, Serge "snerge" Savard (snerge@myrealbox.com)
   //
   //    Purpose : A php class that retrieves the SOF2 servers status and format it to be displayed
   //              like (as far as I could do) in-game score.
   //
   //    ** Should work for Infiltration, Capture the Flag, Demolition, Elimination, Team Deadmatch and
   //    ** Deadmatch. If you have *any* suggestion to improve the layout, code feel free to contact me.
   //    ** Don't ask me to put ratio, deaths, player with flag, case, bomb, I've already looked into it and it can't be done.
   //    
   //    Changelog:
   //     Version 0.9b        19/05/2003 Public Beta release 
   //
   //    Syntax:
   //
   //    Function getServerStatus(serveraddress,serverport,timeout)
   //    Get player/servervar info from server
   //
   //    All results are returned in membervariables:
   //
   //    Greetings : Henrik Schack Jensen for letting me use is code
   //                RTW*BlackFly for finding the project's name
   //                RTW Clans (http://www.rtwclan.com) 
   //                For having a nice server (which I used to test my shit :P)          
   //                Thanks to all the people who gave me their feedbacks and comments
   //
   //    phpSOF2Watch full source is available at http://snerge.mine.nu
   //    Class Quake 3 Demosource is available at http://www.gameserver.dk/
   //
   //    Install :
   //     - Extract or copy index.php, sof2.php and maps directory to your http root directory or
   //       in a sub-directory
   //     - Make sure they are readable by your webserver (chmod 644 sof2.php)
   //     - Edit index.php and set the server (Line 53) address and port just under the BODY tag
   //     - Set the map directory if needed
   //     - Point your browser to index.php and it should work, problems ? mail me
   //    **********************************************************************************************
   //    ******        I had never done php before, I know there is place for improvement        ******
   //    **********************************************************************************************
   
   function removefunchars($data) {
      $result="";
      for ($i=0;$i<strlen($data);$i++) {
         if ($currentchar=ord(substr($data,$i,1)) == 94) {
            $i++; } 
		 else { $temp = $temp . substr($data,$i,1);  }
      }
      $result = $temp;
      return $result;
   }

   Class SoldierOfFortune2 {
       var $m_servervars        ="";        // Info about the server, From Quake 3 Class

       //
       // Get exact time, used for timeout counting
       // From Quake 3 Class
       function timenow() {
           return doubleval(ereg_replace('^0\.([0-9]*) ([0-9]*)$','\\2.\\1',microtime()));
       }
       //
       // Read raw data from server
       // From Quake 3 Class
       function getServerData($command,$serveraddress,$portnumber,$waittime) {
           $serverdata        ="";
           $serverdatalen=0;

           if ($waittime< 500) $waittime= 500;
           if ($waittime>2000) $waittime=2000;
           $waittime=doubleval($waittime/1000.0);
           if (!$cssocket=fsockopen("udp://".$serveraddress,$portnumber,$errnr)) {
               $this->errmsg="No connection";
               return "";
           }
           socket_set_blocking($cssocket,true);
           socket_set_timeout($cssocket,0,500000);
           fwrite($cssocket,$command,strlen($command));
           // Mark
           $starttime=$this->timenow();
           do {
               $serverdata.=fgetc($cssocket);
               $serverdatalen++;
               $socketstatus=socket_get_status($cssocket);
               if ($this->timenow()>($starttime+$waittime)) {
                   $this->errmsg="Connection timed out";
                   fclose($cssocket);
                   return "";
               }
           } while ($socketstatus["unread_bytes"] );
           fclose($cssocket);
           return $serverdata;
       }
       // **********************************************************************
       // getServerStatus
       // Read rules/setup from the gameserver into m_servervars
       // Return true if successful
	   // From Quake 3 Class but modified for SOF2
       // **********************************************************************
       function getServerStatus($serveraddress,$portnumber,$timeout) {

           $cmd="\xFF\xFF\xFF\xFFgetstatus\n";
           $serverdata=$this->getServerData($cmd,$serveraddress,$portnumber,$timeout);
           if (strlen($serverdata)>20) {
               $serverdata=substr($serverdata,20); } 
		   else { return false; }
           $srvvars=substr($serverdata,0,strpos($serverdata,"\n"))."\\";
           $players=substr($serverdata,strpos($serverdata,"\n")+1);
           $servlength = strlen($serverdata);
           $red=substr($serverdata,strpos($serverdata,"redscore")+9);
           $red=substr($red,0,strpos($red,"bluescore")-1);
           $this->red=$red;
           //echo "{$serverdata}<BR><BR>"; // Used for debugging
          $blue=substr($serverdata,strpos($serverdata,"bluescore")+10);
          $pos=strpos($blue," ")-2;
          if ($pos <> -2) {
             $blue=substr($blue,0,$pos); } 
          else { $blue = 0; }
          $playerlist=substr($serverdata,strpos($serverdata,"bluescore")+12);
          $this->blue=$blue;
          $intRed = 1;
          $intBlue = 1;
          $intSpec = 1;
          $intDm = 1;
          $bluearray = array(
                             1 => array()
                            );
          $redarray = array(
                             1 => array()
                            );
          $specarray = array(
                             1 => array()
                            );
          $dmarray = array(
                           1 => array()
                          );
          while($playerlist <> "") {
             $player1=substr($playerlist,0,strpos($playerlist,"\"\n"));
             $playerlist=substr($playerlist,strlen($player1)+2);
             $score=substr($player1,0,strpos($player1," "));
             $player1=substr($player1,strlen($score)+1);
             $ping=substr($player1,0,strpos($player1," "));
             $player1=substr($player1,strlen($ping)+1);
             $team=substr($player1,0,strpos($player1," "));
             $player1=substr($player1,strlen($team)+2);
             $player1=removefunchars($player1);
             //Place the player in the right team array       
             if ($team == 2) {
                $bluearray[$intBlue][1] = $score;
                $bluearray[$intBlue][2] = $ping;
                $bluearray[$intBlue][3] = $player1;
                $intBlue++;
             }  
             if ($team == 1) { 
                $redarray[$intRed][1] = $score;
                $redarray[$intRed][2] = $ping;
                $redarray[$intRed][3] = $player1;
                $intRed++;
             }
             if ($team == 3) {
                $specarray[$intSpec][1] = $ping;
                $specarray[$intSpec][2] = $player1;
                $intSpec++;
             }
             if ($team == 0) {
                $dmarray[$intDm][1] = $score;
                $dmarray[$intDm][2] = $ping;
                $dmarray[$intDm][3] = $player1;
                $intDm++;
             }
             $intI++;
          }
          $intI = 1;
          $intJ = 1;
          // Sort red players array by score
          while ($redarray[$intI][3] <> "") {
             while ($redarray[$intJ][3] <> "") {
                if ($redarray[$intJ][1] < $redarray[$intJ+1][1] ) {
                   $scoretemp = $redarray[$intJ][1];
                   $pingtemp = $redarray[$intJ][2];
                   $playertemp = $redarray[$intJ][3];
                   $redarray[$intJ][1] = $redarray[$intJ+1][1];
                   $redarray[$intJ][2] = $redarray[$intJ+1][2];
                   $redarray[$intJ][3] = $redarray[$intJ+1][3];
                   $redarray[$intJ+1][1] = $scoretemp;
                   $redarray[$intJ+1][2] = $pingtemp;
                   $redarray[$intJ+1][3] = $playertemp;
                }
                $intJ++;
             }
             $intJ=1;
             $intI++;
          }
          $intI = 1;
          $intJ = 1;
          // Sort blue players array by score
		  while ($bluearray[$intI][3] <> "") {
             while ($bluearray[$intJ][3] <> "") {
                if ($bluearray[$intJ][1] < $bluearray[$intJ+1][1] ) {
                   $scoretemp = $bluearray[$intJ][1];
                   $pingtemp = $bluearray[$intJ][2];
                   $playertemp = $bluearray[$intJ][3];
                   $bluearray[$intJ][1] = $bluearray[$intJ+1][1];
                   $bluearray[$intJ][2] = $bluearray[$intJ+1][2];
                   $bluearray[$intJ][3] = $bluearray[$intJ+1][3];
                   $bluearray[$intJ+1][1] = $scoretemp;
                   $bluearray[$intJ+1][2] = $pingtemp;
                   $bluearray[$intJ+1][3] = $playertemp;
                }
                $intJ++;
             }
             $intJ=1;
             $intI++;
          }
          // Sort DM Array
          while ($dmarray[$intI][3] <> "") {
             while ($dmarray[$intJ][3] <> "") {
                if ($dmarray[$intJ][1] < $dmarray[$intJ+1][1] ) {
                   $scoretemp = $dmarray[$intJ][1];
                   $pingtemp = $dmarray[$intJ][2];
                   $playertemp = $dmarray[$intJ][3];
                   $dmarray[$intJ][1] = $dmarray[$intJ+1][1];
                   $dmarray[$intJ][2] = $dmarray[$intJ+1][2];
                   $dmarray[$intJ][3] = $dmarray[$intJ+1][3];
                   $dmarray[$intJ+1][1] = $scoretemp;
                   $dmarray[$intJ+1][2] = $pingtemp;
                   $dmarray[$intJ+1][3] = $playertemp;
                }
                $intJ++;
             }
             $intJ=1;
             $intI++;
          }
          // Make the data available to index.php
	  $this->redarray=$redarray;
          $this->bluearray=$bluearray;
          $this->specarray=$specarray;
          $this->dmarray=$dmarray;
          $this->totalblue=$intBlue-1;
          $this->totalred=$intRed-1;
          $this->totaldm=$intDm-1;
 	  $this->m_servervars["sv_currentclients"]=$intBlue-1 + $intRed-1 + $intSpec-1 + $intDm-1;
          // Split servervars and fill into array
          $name_tok = strtok ($srvvars,"\\");
          $val_tok  = strtok ("\\");
          while (strlen($name_tok)) {
             $this->m_servervars[$name_tok]=$val_tok;
             $name_tok = strtok ("\\");
            $val_tok  = strtok ("\\");
          }
          return true;
       } // getServerStatus end
   } // SoldierOfFortune2 class end
?>
